/* Algoritmul lui Kruskal
 * Det. Arborele Partial de Cost Minim
 * Complezitate: O(m * m)
 */ 
#include <fstream>
using namespace std;

ifstream fin("kruskal.in");
ofstream fout("kruskal.out");

struct Muchie {
	int a, b, cost;
};

const int MaxN = 500, MaxE = 10000;
int n, m;          // noduri, muchii
Muchie e[MaxE];    // se retine graful ca un sir de muchii
Muchie apm[MaxE];  // APM
int cmin;          // costul APM
int comp[MaxN];    // comp[i] = j;  (nodul i se gaseste in multimea (arborele) j)


void CitesteGraf();
void SorteazaMuchii();
void Init();
void Kruskal();
void AfiseazaAPM();

int main()
{
	CitesteGraf();
	Init();
	Kruskal();
	AfiseazaAPM();
}
   
void CitesteGraf()
{
	fin >> n;
	while (fin >> e[m].a >> e[m].b >> e[m].cost)
		m++;
}

void SorteazaMuchii()
{
	Muchie aux;
	for (int i = 0; i < m - 1; ++i)
		for (int j = i + 1; j < m; ++j)
			if (e[i].cost > e[j].cost)
			{
				aux = e[i];
				e[i] = e[j];
				e[j] = aux;
			}
}

void Init()
{
	for (int i = 1; i <= n; ++i)
		comp[i] = i;
}

void Kruskal() // alg greedy
{
	int k = 0;   // nr de muchii in APM
	int c1, c2;  // componentele conexe (arborii) din care fac parte nodurile a si b	
	
	SorteazaMuchii();
	for (int i = 0; i < m; ++i)
	{
		// find - O(1)
		c1 = comp[e[i].a];
		c2 = comp[e[i].b];
		if (c1 != c2) // a si b fac parte din arbori diferiti
		{
			cmin += e[i].cost;
			apm[k++] = e[i];
			
			// union  O(n)
			for (int j = 1; j <= n; ++j)
				if (comp[j] == c2)
					comp[j] = c1;
		
			if (k == n - 1) // am obtinut APM
				break;
		}
		
	}
}

void AfiseazaAPM()
{
	fout << cmin << '\n';
	
	for (int i = 0; i < n - 1; ++i)
		fout << apm[i].a << ' ' << apm[i].b << ' '
			 << apm[i].cost << '\n';
}


